hdu 4630 No Pain No Game 线段树离线处理

题目链接

求出一个区间内任意两个数的gcd的最大值。

先将询问读进来然后按r值排序。 将每一个数因数分解, 对每一个因子x, 如果pre[x]!=-1, 那么就更新update(pre[x], x, 1, n, 1), 当前的坐标i和某一个询问的r相同时进行查询。

具体看代码。注意l和r相同时答案是0。 初始的时候将maxx数组都弄成1.

谜之WA了n次才发现是数组开小了。

#include <iostream>
#include <vector>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <stack>
#include <bitset>
using namespace std;
#define pb(x) push_back(x)
#define ll long long
#define mk(x, y) make_pair(x, y)
#define lson l, m, rt<<1
#define mem(a) memset(a, 0, sizeof(a))
#define rson m+1, r, rt<<1|1
#define mem1(a) memset(a, -1, sizeof(a))
#define mem2(a) memset(a, 0x3f, sizeof(a))
#define rep(i, n, a) for(int i = a; i<n; i++)
#define fi first
#define se second
typedef pair<int, int> pll;
const double PI = acos(-1.0);
const double eps = 1e-8;
const int mod = 1e9+7;
const int inf = 1061109567;
const int dir[][2] = { {-1, 0}, {1, 0}, {0, -1}, {0, 1} };
const int maxn = 5e4+5;
int maxx[maxn<<2], ans[maxn], a[maxn], b[maxn][100], num[maxn], pre[maxn], c[maxn];
struct node
{
    int l, r, id;
    bool operator < (node a) const
    {
        return r<a.r;
    }
}q[maxn];
void build(int l, int r, int rt) {
    maxx[rt] = 1;
    if(l == r)
        return ;
    int m = l+r>>1;
    build(lson);
    build(rson);
}
void update(int p, int val, int l, int r, int rt) {
    if(l == r) {
        maxx[rt] = max(val, maxx[rt]);
        return ;
    }
    int m = l+r>>1;
    if(p<=m)
        update(p, val, lson);
    else
        update(p, val, rson);
    maxx[rt] = max(maxx[rt<<1], maxx[rt<<1|1]);
}
int query(int L, int R, int l, int r, int rt) {
    if(L<=l&&R>=r) {
        return maxx[rt];
    }
    int m = l+r>>1, ret = 0;
    if(L<=m)
        ret = max(ret, query(L, R, lson));
    if(R>m)
        ret = max(ret, query(L, R, rson));
    return ret;
}
int main()
{
    int t, n, m;
    cin>>t;
    while(t--) {
        mem(maxx);
        scanf("%d", &n);
        build(1, n, 1);
        for(int i = 1; i<=n; i++)
            scanf("%d", &a[i]);
        scanf("%d", &m);
        for(int i = 0; i<m; i++) {
            scanf("%d%d", &q[i].l, &q[i].r);
            q[i].id = i;
        }
        sort(q, q+m);
        mem(num);
        mem(b);
        for(int i = 1; i<=n; i++) {
            for(int j = i; j<=n; j+=i) {
                b[j][num[j]++] = i;
            }
        }
        mem1(pre);
        int pos = 0;
        for(int i = 1; i<=n&&pos<m; i++) {
            for(int j = 0; j<num[a[i]]; j++) {
                int tmp = b[a[i]][j];
                if(~pre[tmp]) {
                    update(pre[tmp], tmp, 1, n, 1);
                }
                pre[tmp] = i;
            }
            while(q[pos].r == i) {
                if(q[pos].r == q[pos].l)
                    ans[q[pos].id] = 0;
                else
                    ans[q[pos].id] = query(q[pos].l, q[pos].r, 1, n, 1);
                pos++;
            }
        }
        for(int i = 0; i<m; i++) {
            printf("%d\n", ans[i]);
        }
    }
    return 0;
}
时间: 2024-10-13 19:41:26

hdu 4630 No Pain No Game 线段树离线处理的相关文章

HDU 4630 No Pain No Game (线段树离线查询)

题目地址:HDU 4630 这题一看数据范围,于是一直在思考n*logn的算法..实在没想到好方法,找了找题解,发现都是用的n*sqrt(n)*logn的方法...算了算,这个复杂度的确可以过..好吧.. 然后就可以先离线下来将询问按r值排序,然后枚举每个数,并且用sqrt(n)的方法枚举所有的约数,然后对于每个约数,对最近的一次出现的这个约数的地方进行更新.因为对于当前区间来讲,只要最近的这个地方更新了,那么前面的查询肯定都能查到这个地方的最大值,所以前面的不用更新. 代码如下: #inclu

hdu 4630 No Pain No Game (线段树+离线)

题目大意:给你一个无序的1~n的排列a,每次询问[l,r]之间任取两个数得到的最大gcd是多少 先对所有询问离线,然后把问题挂在区间的左端点上(右端点也行) 在预处理完质数,再处理一个next数组,表示 i 的任意一个质因子,这样我们分解质因数的时间降低到而不是 因为能对答案产生贡献的都是成对出现的两个数 所以每次记录一个last[i],表示数 i 上一次出现的位置 当遍历到第 i 个数时,分解出它的所有质因数,然后搜出它所有的因子,因子个数大约不会超过,均摊下来就更少了 那么,a[i] 的某个

hdu 4630 No Pain No Game(线段树+离线操作)

No Pain No Game Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 1769    Accepted Submission(s): 748 Problem Description Life is a game,and you lose it,so you suicide. But you can not kill yours

gcd(线段树离线处理)——HDU 4630

对应HDU题目:点击打开链接 No Pain No Game Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 1801    Accepted Submission(s): 770 Problem Description Life is a game,and you lose it,so you suicide. But you can

hdu 1394 Minimum Inversion Number(线段树)

Minimum Inversion Number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 10853    Accepted Submission(s): 6676 Problem Description The inversion number of a given number sequence a1, a2, ..., a

HDU 4902 (牛叉的线段树)

Nice boat Problem Description There is an old country and the king fell in love with a devil. The devil always asks the king to do some crazy things. Although the king used to be wise and beloved by his people. Now he is just like a boy in love and c

HDU Wow! 4893 Such Sequence!(线段树)

HDU 4893 Wow! Such Sequence! 题目链接 题意:给定一个序列,3种操作,单点添加值,查询区间和,把区间和变成最接近的婓波那契数 思路:线段树,就是第三个操作麻烦,就在结点添加一个值,标记它区间是不是都是婓波那契数了,然后修改区间的时候,如果区间是了就不用修改,如果不是就继续往后一层推即可 代码: #include <cstdio> #include <cstring> #include <cstdlib> #define lson(x) ((x

HDU 4893 Wow! Such Sequence! 水线段树

思路: 线段树走起.. 写完这题就退役T^T 单点更新的时候直接找到这个点的最近fib,然后维护当前和 和 fib的和 #include<stdio.h> #include<string.h> #include<iostream> #include<math.h> #include<algorithm> #include<queue> #include<map> #include<set> #include&l

HDU 1754 I Hate It (线段树 单点更新)

题目链接 中文题意,与上题类似. 1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #include <queue> 5 #include <cstdlib> 6 #include <algorithm> 7 const int maxn = 200000+10; 8 using namespace std; 9 int a[maxn], n, m; 10